Index: trunk/MagicSoft/Mars/datacenter/db/builddatasets.php
===================================================================
--- trunk/MagicSoft/Mars/datacenter/db/builddatasets.php	(revision 9493)
+++ trunk/MagicSoft/Mars/datacenter/db/builddatasets.php	(revision 9498)
@@ -832,4 +750,5 @@
 
             mysql_free_result($result0);
+            mysql_free_result($result1);
         }
         mysql_close($db_id);
@@ -843,37 +762,127 @@
     include ("magicdefs.php");
 
+//    $debug="yes";
+    session_start();
+    if ($debug)
+    {
+        echo "GET: ";
+        print_r($_GET);
+        echo " <br>";
+
+        echo "POST: ";
+        print_r($_POST);
+        echo " <br>";
+    }
+
+    // set values given by $_GET
+    foreach ($_GET as $element => $value)
+        $_SESSION[$element]=$value;
+
+    // unset values in case of 'Reset'
+    if (empty($_GET))
+        foreach($_SESSION as $element => $value)
+            unset($_SESSION[$element]);
+
+    // set values given by $_POST
+    if (!empty($_POST))
+        foreach ($_POST as $element => $value)
+            $_SESSION[$element]=$value;
+
+
+
+    if ($debug)
+        print_r($_SESSION);
+
+    // remove sequence from selection
+    if (!empty($_POST) && $_SESSION["DisplaySelected"]=="yes" && $_SESSION["DisplaySelectedOld"]=="yes")
+        foreach ($_SESSION as $key => $element)
+            if (($_SESSION[$key]=="On") //value is set
+                && (ereg("^[0-9]*ON$", $key) || ereg("^[0-9]*Off$", $key)) // it is a sequence number
+                && (!$_POST[$key]==On)) // the sequence is not given in $_POST any more
+                unset($_SESSION[$key]);
+
+    //store old value of $_SESSION["DisplaySelected"]
+    if ($_SESSION["DisplaySelected"]=="yes")
+    {
+        unset($_SESSION["fNumStart"]);
+        $_GET["fNumStart"]=0;
+        $_SESSION["DisplaySelectedOld"]="yes";
+    }
+    else
+        $_SESSION["DisplaySelectedOld"]="no";
+
+    $_SESSION["sequon"]=" ";
+    $_SESSION["sequoff"]=" ";
+    foreach($_SESSION as $key => $val)
+        if ($val=="On")
+        {
+            if (ereg("^[0-9]*ON$", $key))
+                $_SESSION["sequon"].=str_replace("ON", " ", $key);
+            if (ereg("^[0-9]*Off$", $key))
+                $_SESSION["sequoff"].=str_replace("Off", " ", $key);
+        }
+    if ($_SESSION["sequon"]==" " && $_SESSION["sequoff"]==" ")
+    {
+        $_SESSION["DisplaySelected"]="no";
+        $_SESSION["DisplaySelectedOld"]="no";
+    }
+
     ini_set("display_errors", "On");
     ini_set("mysql.trace_mode", "On");
 
-    $sitepw="\$1\$ml/Gld67\$zOvhC4vFrLCkbAzQs2swo1";
-    $siteuser="dcdb";
-
-
-    if (!isset($_SERVER['PHP_AUTH_USER']) || crypt($_SERVER['PHP_AUTH_PW'], $sitepw)!=$sitepw || $_SERVER['PHP_AUTH_USER']!=$siteuser)
+    if (!isset($_SERVER['PHP_AUTH_USER']))
     {
         header('WWW-Authenticate: Basic realm="Build Datasets"');
         header('HTTP/1.0 401 Unauthorized');
-        echo 'Cancelled.';
         return;
     }
     else
     {
-//    echo "<p>Hello {$_SERVER['PHP_AUTH_USER']}.</p>";
-//    echo "<p>You entered {$_SERVER['PHP_AUTH_PW']} as your password.</p>";
-//    printf("pw: %s", crypt($_SERVER['PHP_AUTH_PW']));
-
-        if (crypt($_SERVER['PHP_AUTH_PW'], $sitepw)!=$sitepw || $_SERVER['PHP_AUTH_USER']!=$siteuser)
-        {
-            printf("<br>pw or user incorrect<br>");
+        $db_id = mysql_connect($host, $user, $pw);
+        if ($db_id==FALSE)
+        {
+            printf("mysql_connect returned the following error:<br>");
+            printf("%s<br>", mysql_error());
+            die("");
+        }
+
+        $userquery   = "SELECT fUserName, fPassword, fUserKEY FROM " . $db . ".User ORDER BY fUserKEY";
+        $userresult  = mysql_query($userquery);
+        if (!$userresult)
+            echo "query failed";
+        $validuser="no";
+        while ($userrow = mysql_fetch_assoc($userresult))
+        {
+//            echo crypt($_SERVER['PHP_AUTH_PW']). "<br>";
+            if (crypt($_SERVER['PHP_AUTH_PW'], $userrow["fPassword"])==$userrow["fPassword"]
+                && $_SERVER['PHP_AUTH_USER']==$userrow["fUserName"])
+            {
+                $validuser="yes";
+                $_SESSION["user"]=$userrow["fUserKEY"];
+            }
+        }
+        mysql_free_result($userresult);
+        if ($validuser=="no")
+        {
+            printf("<br>Password or username incorrect<br>");
             return;
         }
     }
 
-    if (!empty($_GET["fSendTxt"]))
-    {
-        header("Content-type: application/octet");
-        header("Content-Disposition: attachment; filename=query-result.txt");
-
-        PrintPage("0", $host, $user, $pw, $db, $alias, $rightalign, $checkwhere, $checkgroup, $checkstatusgroup, $limitsmean, $limitsmin, $limitsmax, $needs);
+    if (!empty($_SESSION["fSendTxt"]))
+    {
+        header("Content-Type: application/octet");
+        switch($_SESSION["fSendTxt"])
+        {
+        case 1:
+            header("Content-Disposition: attachment; filename=query-result.txt");
+            PrintPage("0", $host, $user, $pw, $db, $alias, $rightalign, $checkwhere, $checkgroup, $checkstatusgroup, $limitsmean, $limitsmin, $limitsmax, $needs);
+            break;
+        case 2:
+            header("Content-Disposition: attachment; filename=dataset_".str_replace(" ", "_", $_SESSION["name"]).".txt");
+            PrintDataSetFile();
+            echo "hallo\n";
+        }
+        unset($_SESSION["fSendTxt"]);
     }
     else
@@ -883,7 +892,9 @@
         $environment = sizeof($_GET);
 
-        InitGet($_GET);
-        if (empty($_GET["fPrintTable"]))
-            PrintForm($_GET, $host, $user, $pw, $db, $limitsmean, $limitsmin, $limitsmax, $alias);
+        // Find out whether it is the first call to the php script
+        $first = empty($_GET["fRunMin"]) && empty($_GET["fRunMax"]);
+        InitBuildDataSets($first);
+        if (empty($_SESSION["fPrintTable"]))
+            PrintForm($host, $user, $pw, $db, $limitsmean, $limitsmin, $limitsmax, $alias);
 
         if ($environment==0)
@@ -891,5 +902,5 @@
         else
         {
-            if (empty($_GET["fPrintTable"]))
+            if (empty($_SESSION["fPrintTable"]))
                 PrintPage("1", $host, $user, $pw, $db, $alias, $rightalign, $checkwhere, $checkgroup, $checkstatusgroup, $limitsmean, $limitsmin, $limitsmax, $needs);
             else
@@ -902,4 +913,4 @@
     ini_set("display_errors", "Off");
     ini_set("mysql.trace_mode", "Off");
-}
+
 ?>
Index: trunk/MagicSoft/Mars/datacenter/db/ctadefs.php
===================================================================
--- trunk/MagicSoft/Mars/datacenter/db/ctadefs.php	(revision 9493)
+++ trunk/MagicSoft/Mars/datacenter/db/ctadefs.php	(revision 9498)
@@ -25,10 +25,10 @@
 $checkwhere = array
     (
-     "fParticleTypeName"                 => CheckWhere("fParticleTypeKEY",                 $_GET),
+     "fParticleTypeName"  => CheckWhere("fParticleTypeKEY"),
     );
 
 $checkgroup = array
     (
-     "fParticleTypeName"                 => CheckGroup("fParticleTypeKEY",                 $_GET),
+     "fParticleTypeName"  => CheckGroup("fParticleTypeKEY"),
     );
 
@@ -36,10 +36,10 @@
 $checkstatusgroup = array
     (
-     "fCorsikaSimTelarray" => CheckStatusGroup("fCorsikaSimTelarrayStatus", $_GET),
-     "fChimp"              => CheckStatusGroup("fChimpStatus",              $_GET),
-     "fCTAStar"            => CheckStatusGroup("fCTAStarStatus",            $_GET),
-     "fStereoB"            => CheckStatusGroup("fStereoBStatus",            $_GET),
-     "fStereoC"            => CheckStatusGroup("fStereoCStatus",            $_GET),
-     "fStereoG"            => CheckStatusGroup("fStereoGStatus",            $_GET),
+     "fCorsikaSimTelarray" => CheckStatusGroup("fCorsikaSimTelarrayStatus"),
+     "fChimp"              => CheckStatusGroup("fChimpStatus"),
+     "fCTAStar"            => CheckStatusGroup("fCTAStarStatus"),
+     "fStereoB"            => CheckStatusGroup("fStereoBStatus"),
+     "fStereoC"            => CheckStatusGroup("fStereoCStatus"),
+     "fStereoG"            => CheckStatusGroup("fStereoGStatus"),
     );
 
Index: trunk/MagicSoft/Mars/datacenter/db/ctamcinfo.php
===================================================================
--- trunk/MagicSoft/Mars/datacenter/db/ctamcinfo.php	(revision 9493)
+++ trunk/MagicSoft/Mars/datacenter/db/ctamcinfo.php	(revision 9498)
@@ -1,5 +1,5 @@
 <?php
 {
-    function CreateQuery($_GET, $alias, $checkwhere, $checkgroup, $checkstatusgroup, $needs, $timelimits)
+    function CreateQuery($alias, $checkwhere, $checkgroup, $checkstatusgroup, $needs, $timelimits)
     {
         $fromtable="MCRunData";
@@ -15,5 +15,5 @@
                 $statusgroups++;
 
-        $query0 = "SELECT ";
+        $query0 = "SELECT SQL_CALC_FOUND_ROWS ";
 
         if ($groups>0 || $statusgroups>0)
@@ -204,13 +204,15 @@
 
         if (empty($_GET["fNumStart"]))
-            $_GET["fNumStart"]=0;
+            $start=0;
+        else
+            $start=$_GET["fNumStart"];
 
         if (empty($_GET["fSendTxt"]))
-            $query0 .= " LIMIT " . $_GET["fNumStart"] . ", " . $_GET["fNumResults"];
+            $query0 .= " LIMIT " . $start . ", " . $_GET["fNumResults"];
 
         return $query0;
     }
 
-    function InitGet($_GET)
+    function InitGet()
     {
         // Find out whether it is the first call to the php script
@@ -220,5 +222,5 @@
     }
 
-    function PrintForm($_GET, $host, $user, $pw, $db)
+    function PrintForm($host, $user, $pw, $db)
     {
         printf("<center>\n");
@@ -279,16 +281,18 @@
         mysql_query("SET BIG_TABLES=1"); // necessary for mySQL <= 4
 
-        $query0 = CreateQuery($_GET, $alias, $checkwhere, $checkgroup, $checkstatusgroup, $needs, $timelimits);
+        $query0 = CreateQuery($alias, $checkwhere, $checkgroup, $checkstatusgroup, $needs, $timelimits);
 
         $result0 = mysql_query($query0, $db_id);
+        $result1 = mysql_query("SELECT FOUND_ROWS()", $db_id);
 
         if ($result0)
         {
             if ($html=="1" || $html=="2")
-                PrintMagicTable($result0, $alias, $rightalign, "", "", "", "", $_GET);
+                PrintMagicTable($result0, $alias, $rightalign, "", "", "", $result1);
             else
                 PrintText($result0);
 
             mysql_free_result($result0);
+            mysql_free_result($result1);
         }
         mysql_close($db_id);
@@ -298,5 +302,5 @@
 
     include ("include.php");
-    include ("db.php");
+    include ("db2.php");
     include ("menu.php");
     include ("ctadefs.php");
@@ -319,7 +323,7 @@
         $environment = sizeof($_GET);
 
-        InitGet($_GET);
+        InitGet();
         if (empty($_GET["fPrintTable"]))
-            PrintForm($_GET, $host, $user, $pw, $db);
+            PrintForm($host, $user, $pw, $db);
 
         if ($environment==0)
Index: trunk/MagicSoft/Mars/datacenter/db/culminating.php
===================================================================
--- trunk/MagicSoft/Mars/datacenter/db/culminating.php	(revision 9493)
+++ trunk/MagicSoft/Mars/datacenter/db/culminating.php	(revision 9498)
@@ -10,5 +10,5 @@
                 $groups++;
 
-        $query0  = "SELECT ";
+        $query0 = "SELECT SQL_CALC_FOUND_ROWS ";
 
         if ($groups>0)
@@ -223,13 +223,15 @@
 
         $result0 = mysql_query($query0, $db_id);
+        $result1 = mysql_query("SELECT FOUND_ROWS()", $db_id);
 
         if ($result0)
         {
             if ($html=="1")
-                PrintMagicTable($result0, $alias, $rightalign, "", "", "", "", $_GET);
+                PrintMagicTable($result0, $alias, $rightalign, "", "", "", $result1);
             else
                 PrintText($result0);
 
             mysql_free_result($result0);
+            mysql_free_result($result1);
         }
         mysql_close($db_id);
Index: trunk/MagicSoft/Mars/datacenter/db/datacheck.php
===================================================================
--- trunk/MagicSoft/Mars/datacenter/db/datacheck.php	(revision 9493)
+++ trunk/MagicSoft/Mars/datacenter/db/datacheck.php	(revision 9498)
@@ -20,5 +20,5 @@
                 $enumgroups++;
 
-        $query0 = "SELECT ";
+        $query0 = "SELECT SQL_CALC_FOUND_ROWS ";
 
         if ($groups>0)
@@ -416,13 +416,15 @@
 
         $result0 = mysql_query($query0, $db_id);
+        $result1 = mysql_query("SELECT FOUND_ROWS()", $db_id);
 
         if ($result0)
         {
             if ($html=="1" || $html=="2")
-                PrintMagicTable($result0, $alias, $rightalign, "", "", "", "", $_GET);
+                PrintMagicTable($result0, $alias, $rightalign, "", "", "", $result1);
             else
                 PrintText($result0);
 
             mysql_free_result($result0);
+            mysql_free_result($result1);
         }
         mysql_close($db_id);
Index: trunk/MagicSoft/Mars/datacenter/db/datasetinfo-aio.php
===================================================================
--- trunk/MagicSoft/Mars/datacenter/db/datasetinfo-aio.php	(revision 9493)
+++ trunk/MagicSoft/Mars/datacenter/db/datasetinfo-aio.php	(revision 9498)
@@ -15,5 +15,5 @@
                 $statusgroups++;
 
-        $query0 = "SELECT ";
+        $query0 = "SELECT SQL_CALC_FOUND_ROWS ";
 
         if ($groups>0 || $statusgroups>0)
@@ -232,13 +232,15 @@
 
         $result0 = mysql_query($query0, $db_id);
+        $result1 = mysql_query("SELECT FOUND_ROWS()", $db_id);
 
         if ($result0)
         {
             if ($html=="1" || $html=="2")
-                PrintMagicTable($result0, $alias, $rightalign, "", "", "", "", $_GET);
+                PrintMagicTable($result0, $alias, $rightalign, "", "", "", $result1);
             else
                 PrintText($result0);
 
             mysql_free_result($result0);
+            mysql_free_result($result1);
         }
         mysql_close($db_id);
Index: trunk/MagicSoft/Mars/datacenter/db/datasetinfo.php
===================================================================
--- trunk/MagicSoft/Mars/datacenter/db/datasetinfo.php	(revision 9493)
+++ trunk/MagicSoft/Mars/datacenter/db/datasetinfo.php	(revision 9498)
@@ -15,5 +15,5 @@
                 $statusgroups++;
 
-        $query0 = "SELECT ";
+        $query0 = "SELECT SQL_CALC_FOUND_ROWS ";
 
         if ($groups>0)
@@ -372,13 +372,15 @@
 
         $result0 = mysql_query($query0, $db_id);
+        $result1 = mysql_query("SELECT FOUND_ROWS()", $db_id);
 
         if ($result0)
         {
             if ($html=="1" || $html=="2")
-                PrintMagicTable($result0, $alias, $rightalign, "", "", "", "", $_GET);
+                PrintMagicTable($result0, $alias, $rightalign, "", "", "", $result1);
             else
                 PrintText($result0);
 
             mysql_free_result($result0);
+            mysql_free_result($result1);
         }
         mysql_close($db_id);
Index: trunk/MagicSoft/Mars/datacenter/db/dbstatus.php
===================================================================
--- trunk/MagicSoft/Mars/datacenter/db/dbstatus.php	(revision 9493)
+++ trunk/MagicSoft/Mars/datacenter/db/dbstatus.php	(revision 9498)
@@ -51,5 +51,5 @@
                 $statusgroups++;
 
-        $query0 = "SELECT ";
+        $query0 = "SELECT SQL_CALC_FOUND_ROWS ";
 
         if ($groups>0)
@@ -355,13 +355,15 @@
 
         $result0 = mysql_query($query0, $db_id);
+        $result1 = mysql_query("SELECT FOUND_ROWS()", $db_id);
 
         if ($result0)
         {
             if ($html=="1" || $html=="2")
-                PrintMagicTable($result0, $alias, $rightalign, "", "", "", "", $_GET);
+                PrintMagicTable($result0, $alias, $rightalign, "", "", "", $result1);
             else
                 PrintText($result0);
 
             mysql_free_result($result0);
+            mysql_free_result($result1);
         }
         mysql_close($db_id);
Index: trunk/MagicSoft/Mars/datacenter/db/findoffdata.php
===================================================================
--- trunk/MagicSoft/Mars/datacenter/db/findoffdata.php	(revision 9493)
+++ trunk/MagicSoft/Mars/datacenter/db/findoffdata.php	(revision 9498)
@@ -15,5 +15,5 @@
                 $statusgroups++;
 
-        $query0 = "SELECT ";
+        $query0 = "SELECT SQL_CALC_FOUND_ROWS ";
 
         if ($groups>0)
@@ -409,13 +409,15 @@
 
         $result0 = mysql_query($query0, $db_id);
+        $result1 = mysql_query("SELECT FOUND_ROWS()", $db_id);
 
         if ($result0)
         {
             if ($html=="1" || $html=="2")
-                PrintMagicTable($result0, $alias, $rightalign, $limitsmean, $limitsmin, $limitsmax, "", $_GET);
+                PrintMagicTable($result0, $alias, $rightalign, $limitsmean, $limitsmin, $limitsmax, $result1);
             else
                 PrintText($result0);
 
             mysql_free_result($result0);
+            mysql_free_result($result1);
         }
         mysql_close($db_id);
Index: trunk/MagicSoft/Mars/datacenter/db/include.php
===================================================================
--- trunk/MagicSoft/Mars/datacenter/db/include.php	(revision 9493)
+++ trunk/MagicSoft/Mars/datacenter/db/include.php	(revision 9498)
@@ -255,9 +255,7 @@
 }
 
+//for download of output
 function PrintText($result0)
 {
-//    header("Content-type: application/octet");
-//    header("Content-Disposition: attachment; filename=query-result.txt");
-
     while ($row0 = mysql_fetch_assoc($result0))
     {
@@ -293,20 +291,7 @@
 }
 
-function Checkbox2($val, $set, $text)
-{
-    $value=$val.$set;
-    switch ($set)
-    {
-    case  "ON":
-        if (!isset($_POST["submit"]) && ereg(" ".$val." ", $_GET["Set"]))
-            $_POST[$value]="On";
-        break;
-    case "Off":
-        if (!isset($_POST["submit"]) && ereg(" ".$val." ", $_GET["Set2"]))
-            $_POST[$value]="On";
-        break;
-    }
-
-    if ($_POST[$value]=="On")
+function Checkbox2($value, $text)
+{
+    if ($_SESSION[$value]=="On")
         $checked = "checked";
     else
@@ -316,5 +301,5 @@
 }
 
-function CheckWhere($column, $_GET)
+function CheckWhere($column)
 {
     foreach ($_GET as $key => $element)
@@ -330,5 +315,5 @@
 }
 
-function CheckGroup($column, $_GET)
+function CheckGroup($column)
 {
     foreach ($_GET as $key => $element)
@@ -344,5 +329,5 @@
 }
 
-function CheckStatusGroup($column, $_GET)
+function CheckStatusGroup($column)
 {
     foreach ($_GET as $key => $element)
@@ -353,5 +338,5 @@
 }
 
-function CheckEnumGroup($column, $_GET)
+function CheckEnumGroup($column)
 {
     foreach ($_GET as $key => $element)
@@ -360,60 +345,4 @@
                 return -1;
     return 0;
-}
-
-function CreateMenu($rows)
-{
-    $menu = "";
-
-    if (empty($_GET["fNumResults"]))
-        return;
-
-    if ($_GET["fNumStart"]!=0)
-    {
-        $uri = htmlspecialchars($_SERVER["REQUEST_URI"]);
-        $pos = strpos($uri, "fNumStart");
-        $amp3=FALSE;
-        if ($pos!=FALSE)
-        {
-            $amp1 = substr($uri, 0, $pos-1);
-            $amp2 = substr($uri, $pos);
-            $amp3 = strchr($amp2, "&");
-
-            $uri = $amp1;
-        }
-        $pos = $_GET["fNumStart"]-$rows;
-        if ($pos<0)
-            $pos=0;
-        $uri .= "&fNumStart=" . $pos;
-        if ($amp3!=FALSE)
-            $uri .= $amp3;
-
-        $menu .= "<A HREF='" . $uri . "'><<< Prev</A>\n";
-    }
-
-    $menu .= "&nbsp;&nbsp;&nbsp;---&nbsp;<B>";
-    $menu .= $_GET["fNumStart"];
-    $menu .= "</B>&nbsp;---&nbsp;&nbsp;&nbsp;\n";
-
-    if ($rows==$_GET["fNumResults"])
-    {
-        $uri = $_SERVER["REQUEST_URI"];
-        $pos = strpos($uri, "fNumStart");
-        $amp3=FALSE;
-        if ($pos!=FALSE)
-        {
-            $amp1 = substr($uri, 0, $pos-1);
-            $amp2 = substr($uri, $pos);
-            $amp3 = strchr($amp2, "&");
-
-            $uri = $amp1;
-        }
-        $uri .= "&fNumStart=" . ($_GET["fNumStart"]+$rows);
-        if ($amp3!=FALSE)
-            $uri .= $amp3;
-
-        $menu .= "<A HREF='" . htmlspecialchars($uri) . "'>Next >>></A>\n";
-    }
-    return $menu;
 }
 
@@ -455,5 +384,136 @@
 }
 
-function PrintMagicTable($result0, $alias, $rightalign, $limitsmean, $limitsmin, $limitsmax, $form, $_GET)
+//function for button in builddatasets.php
+function GetClearedURL($all)
+{
+//    $url=htmlspecialchars($_SERVER["REQUEST_URI"]);
+    $url=$_SERVER["REQUEST_URI"];
+//    echo "before:".$url."<br>";
+    if ($all=="yes")
+    {
+//        echo "replace <br>";
+//        $url=str_replace("&DisplaySelected", "halo", $url);
+        $url=str_replace("&DisplaySelected=yes", "", $url);
+        $url=str_replace("&DisplaySelected=no", "", $url);
+    }
+    $url=str_replace("&insert=yes", "", $url);
+    $url=str_replace("&fSendTxt=2", "", $url);
+    $url=str_replace("&fSendTxt=1", "", $url);
+//    echo "after:".$url."<br>";
+    $url=htmlspecialchars($url);
+    return $url;
+}
+
+function PrintUpdateDataSetButton()
+{
+    if (empty($_SESSION["insert"]))
+        printf("<input type='submit' value='Update Data Set'>&nbsp;&nbsp;&nbsp;\n");
+    else
+        printf("<input type='button' value='Continue' onClick='self.location.href=\"%s\"'>&nbsp;&nbsp;&nbsp;\n", GetClearedURL());
+
+}
+
+//function for button in builddatasets.php
+function PrintDisplaySequencesButtons()
+{
+    if ($_SESSION["DisplaySelected"]!="yes" && ($_SESSION["sequon"]!=" " || $_SESSION["sequoff"]!=" "))
+    {
+        PrintUpdateDataSetButton();
+        printf("<input type='button' value='Display Selected Sequences' onClick='self.location.href=\"%s&DisplaySelected=yes\"'><br><br>\n", GetClearedURL("yes"));
+    }
+
+    if ($_SESSION["DisplaySelected"]=="yes")
+    {
+        PrintUpdateDataSetButton();
+        printf("<input type='button' value='Display All Sequences' onClick='self.location.href=\"%s&DisplaySelected=no\"'>\n", GetClearedURL("yes"));
+        printf("&nbsp;&nbsp;&nbsp;<i>Currently only selected sequences are displayed.</i><br><br>\n");
+    }
+}
+
+
+function ReplaceInUri($name, $rows, $direction, $result1=0)
+{
+    $uri = htmlspecialchars($_SERVER["REQUEST_URI"]);
+    $pos = strpos($uri, "fNumStart");
+    $amp3=FALSE;
+    if ($pos!=FALSE)
+    {
+        $amp1 = substr($uri, 0, $pos-1);
+        $amp2 = substr($uri, $pos);
+        $amp3 = strchr($amp2, "&");
+
+        $uri = $amp1;
+    }
+
+    switch($direction)
+    {
+    case 0:
+        $pos = $_GET["fNumStart"]-$rows;
+        if ($pos<0)
+            $pos=0;
+        break;
+    case 1:
+        $pos = $_GET["fNumStart"]+$rows;
+        break;
+    case 2:
+        $pos = 0;
+        break;
+    case 3:
+        $row1 = mysql_fetch_assoc($result1);
+        $pos = $row1["FOUND_ROWS()"]-$rows+1;
+        break;
+    }
+
+    $uri .= "&fNumStart=" . $pos;
+    if ($amp3!=FALSE)
+        $uri .= $amp3;
+
+    switch($direction)
+    {
+    case 0:
+        $link .= " <A HREF='" . $uri . "'>< Prev</A> \n";
+        break;
+    case 1:
+        $link .= " <A HREF='" . $uri . "'>Next ></A> \n";
+        break;
+    case 2:
+        $link .= " <A HREF='" . $uri . "'><< First</A> \n";
+        break;
+    case 3:
+        $link .= " <A HREF='" . $uri . "'>Last >></A> \n";
+        break;
+    }
+    return $link;
+}
+
+function CreateMenu($rows, $result1)
+{
+    $menu = "";
+
+    if (empty($_GET["fNumResults"]))
+        return;
+
+    if ($_GET["fNumStart"]!=0)
+    {
+        $menu .= ReplaceInUri("fNumStart", $rows, 2);
+        $menu .= ReplaceInUri("fNumStart", $rows, 0);
+    }
+
+    $menu .= "&nbsp;&nbsp;&nbsp;---&nbsp;<B>";
+    if (empty($_GET["fNumStart"]))
+        $menu .= "0";
+    else
+        $menu .= $_GET["fNumStart"];
+    $menu .= "</B>&nbsp;---&nbsp;&nbsp;&nbsp;\n";
+
+    if ($rows==$_GET["fNumResults"])
+    {
+        $menu .= ReplaceInUri("fNumStart", $rows, 1);
+        $menu .= ReplaceInUri("fNumStart", $rows, 3, $result1);
+    }
+    return $menu;
+}
+
+function PrintMagicTable($result0, $alias, $rightalign, $limitsmean, $limitsmin, $limitsmax, $result1, $form="")
 {
     $col   = FALSE;
@@ -470,11 +530,15 @@
 
 
-    $menu = CreateMenu(mysql_num_rows($result0));
-
+    $menu = CreateMenu(mysql_num_rows($result0), $result1);
+
+    if ($form)
+    {
+        printf("<form method='POST'>");
+        PrintDisplaySequencesButtons();
+    }
     printf("\n<center>\n");
-    if ($form)
-        printf("<form method='POST'>");
     if (empty($_GET["fPrintTable"]))
         printf("%s\n", $menu);
+
     printf("<table BORDER='0' style='margin-top:1ex'>\n");
     $counter=0;
@@ -518,6 +582,6 @@
         if ($form)
         {
-            CheckBox2($row0["Sequ"], "ON","");
-            CheckBox2($row0["Sequ"], "Off","");
+            CheckBox2($row0["Sequ"]."ON","");
+            CheckBox2($row0["Sequ"]."Off","");
         }
         foreach ($row0 as $key => $element)
@@ -607,15 +671,18 @@
      */
 
-    printf("<P><B>Number of displayed results: %d</B><P><P>\n", mysql_num_rows($result0));
+    $row1 = mysql_fetch_assoc($result1);
+    printf("<P><B>Number of displayed results: %d of %s in total</B><P><P>\n", mysql_num_rows($result0), $row1["FOUND_ROWS()"]);
     if (empty($_GET["fPrintTable"]))
         printf("%s\n", $menu);
     printf("<P>\n");
+    printf("</center>\n");
 
     if (!$form)
     {
-        printf("</center>\n");
         printf("</td>\n");
         printf("</tr>\n");
     }
+    else
+        PrintDisplaySequencesButtons();
 }
 
Index: trunk/MagicSoft/Mars/datacenter/db/index.php
===================================================================
--- trunk/MagicSoft/Mars/datacenter/db/index.php	(revision 9493)
+++ trunk/MagicSoft/Mars/datacenter/db/index.php	(revision 9498)
@@ -10,5 +10,5 @@
                 $groups++;
 
-        $query0 = "SELECT ";
+        $query0 = "SELECT SQL_CALC_FOUND_ROWS ";
 
         if ($groups>0)
@@ -372,13 +372,15 @@
 
         $result0 = mysql_query($query0, $db_id);
+        $result1 = mysql_query("SELECT FOUND_ROWS()", $db_id);
 
         if ($result0)
         {
             if ($html=="1")
-                PrintMagicTable($result0, $alias, $rightalign, "", "", "", "", $_GET);
+                PrintMagicTable($result0, $alias, $rightalign, "", "", "", $result1);
             else
                 PrintText($result0);
 
             mysql_free_result($result0);
+            mysql_free_result($result1);
         }
         mysql_close($db_id);
